/***********************************************************/
/* MARBLES 1                                               */
/***********************************************************/
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>
#include <GL/freeglut.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include <time.h>

#include "libRAM.h"
#include "libIO.h"

#define pi	 3.14159265
#define true 1
#define false 0
#define blue 0
#define red  1
#define tie  2

/***********************************************************/
/* FUNCTION PROTOTYPES                                     */
/***********************************************************/
int ROUND(double x);

void TEXTURE_MODEL(void);
void LIGHT_MODEL(void);
void CREATE_MARBLES(void);

void DRAW_MENU(void);
void DRAW_BORDER(void);
void DRAW_GRASS(void);
void DRAW_MARBLES(void);
void DRAW_TURN(int);
void DRAW_SCORE(void);
void DRAW_GAME(void);
void DISPLAY_RULES(void);
void DISPLAY_ABOUT(void);
void DISPLAY_WINNER(void);

void RESOLVE_COLLISION(struct _marble*, struct _marble *);
bool MARBLE_COLLISION(struct _marble, struct _marble );
void WALL_COLLISION(struct _marble*);

void GET_INITIAL_VELOCITY(int, int, int, int);
void UPDATE_WINNER(void);
void GAME_ANIMATE(void);

bool MARBLE_SELECTED(struct _marble, int, int);
void myMouse0(int, int, int, int);
void myMouse1(int, int, int, int);
void myResize0(int, int);
void myResize1(int, int);
void myDisplay0(void);
void myDisplay1(void);
void myInit(void);

/***********************************************************/
/* GLOBAL VARIABLES                                        */
/***********************************************************/
// For OpenGL.
GLint window;
GLint vuport;
GLint winWidth  = 1000;
GLint winHeight = 750;
GLint winXpos   = 10;
GLint winYpos   = 10;
GLint vupWidth  = 890;
GLint vupHeight = 730;
GLint vupXpos   = 100;
GLint vupYpos   = 10;
GLint turnCount=0;
// For scene.
int   centerX   = 445;
int   centerY   = 365;
int   delay     = 1000;
int   turn      = red;
int   start     = 0;
int   rules     = 0;
int   about     = 0;

// For lighting.
GLfloat lightX  = -1000.0;
GLfloat lightY  =  1000.0;

// For marbles.
int shadow = 5;
int gROK, gBOK;
int mouseX1, mouseX2, mouseY1, mouseY2;
struct _marble {
   double x, y, z;
   int    radius;
   int    out;
    int onein;
int twoin;
int threein;
   double velocityX, velocityY;
   double restitution;
   double mass;
} Blue[7], Red[7];

// For textures.
GLuint FeltMap, WoodMap, BlueMap, RedMap, TieMap;

// For Scoring.
int redOut, blueOut;
int redScore, blueScore;
// For Restarting
bool restart = false;

/***********************************************************/
/* OBJECT CONTRUCTION                                      */
/***********************************************************/
BUTTON RULES_BUTTON( 10, 720, "Rules");
BUTTON START_BUTTON( 10, 690, "Start");
BUTTON ABOUT_BUTTON( 10,  40, "About");
BUTTON EXIT_BUTTON(  10,  10, "Exit");
WINDOW MAIN_WINDOW(100,  10, 890, 730, "");

